#include "utils_std.hpp"

#include <limits>

namespace
{

void ReadFloatArray(std::istream& is, size_t n, std::vector<float>& result)
{
    float buf = 0; // read buffer

    for (size_t i = 0; i < n; ++i)
    {
        is.read(reinterpret_cast<char*>(&buf), sizeof(float));
        if (is.gcount() != sizeof(float))
        {
            break;
        }
        else
        {
            result.push_back(buf);
        }
    }
}

}

namespace harktool4
{

std::streampos GetFileSize(std::ifstream& ifs)
{
    auto original_pos = ifs.tellg(); // 読み込み位置の保存
    ifs.seekg(0, std::ios::end);
    auto end_pos = ifs.tellg();
    ifs.seekg(original_pos, std::ios::beg); // 読み込み位置の復帰
    return end_pos;
}

std::vector<float> ReadFloatArray(std::istream& is, size_t n)
{
    std::vector<float> result;
    result.reserve(n);
    ::ReadFloatArray(is, n, result);
    return result;
}

std::vector<float> ReadFloatArray(std::istream& is)
{
    std::vector<float> result;
    ::ReadFloatArray(is, std::numeric_limits<size_t>::max(), result);
    return result;
}

}

